Attribute VB_Name = "basIniLesenSpeichern"
Option Explicit


' ===================================================================
'   Ini-Lesen-Schreiben (GES)
'
' Programm-Einstellungen in einer Ini-Datei sichern
'
' Autor:
' Gudio Eisenbeis Software (GES), guidoeisenbeis@web.de, 2003-11-19
' ===================================================================


' INI-Dateien sind folgendermaen aufgebaut:
' Es gibt einen Applications Teil, welcher in eckigen Klammern steht
'   Beispiel:  [Programm Config]     <-- das ist dann ein "Abschnitt"

' Darunter stehen dann die Key's und ihre Werte
'   Beispiel:  Name=Guido Eisenbeis  <-- Schlssel,Gleichzeichen,Wert
'                ^    ^
'        Schlssel    Wert

' Eine INI-Datei, in der z.B. die Koordinaten einer Form
' gespeichert sind knnte so aussehen:

'   [Form1]
'   Left=2000
'   Top=2000
'   Width=4000
'   Hight=4000

' Um den Aufruf mglichst einfach zu gestallten, habe ich
' die Befehle in eine Prozedur "INI_Write" und eine
' Funktion "INI_Read" gepackt, wobei die Funktion
' "INI_Read" den angeforderten Wert zurckgibt.
'
' Beim Ini-Schreiben wird automatisch eine Datei angelegt,
' falls noch keine existiert.
'
' Werden fr optionalen Werte keine Eingaben gemacht, treten
' Standard-Werte an deren Stelle.

' Der Aufruf gestalltet sich sehr einfach:

' Beispiel 1:
' Call INI_Write("Einstellungen", "Beispiel", "Hallo")
' MsgBox INI_Read("Einstellungen", "Beispiel")

' Beispiel 2:
' Call INI_Write("Beispiel", "Mein Hinweis", "(GES)-Software ist die beste!")
' MsgBox INI_Read("Beispiel", "Mein Hinweis", "VB@rchiv - Das einzig Wahre.")

' Mglichkeiten zum Lschen, siehe unten.


Private Declare Function WritePrivateProfileString Lib "kernel32" _
  Alias "WritePrivateProfileStringA" (ByVal lpApplicationName _
  As String, ByVal lpKeyName As Any, ByVal lpString As Any, _
  ByVal lpFileName As String) As Long

Private Declare Function GetPrivateProfileString Lib "kernel32" _
  Alias "GetPrivateProfileStringA" (ByVal lpApplicationName _
  As String, ByVal lpKeyName As Any, ByVal lpDefault As String, _
  ByVal lpReturnedString As String, ByVal nSize As Long, ByVal _
  lpFileName As String) As Long


' Schreiben von Daten in eine INI-Datei
Public Sub INI_Write(ByVal Abschnitt As String, _
                        ByVal SchlsselName As String, _
                        ByVal Wert As String, _
                        Optional ByVal IniPfad As String)
  
  If IniPfad = "" Then IniPfad = App.Path & "\" & App.Title & ".ini"
  Call WritePrivateProfileString(Abschnitt, SchlsselName, Wert, IniPfad)
End Sub

' Lesen von Daten aus einer INI-Datei
Public Function INI_Read(ByVal Abschnitt As String, _
                         ByVal SchlsselName As String, _
                         Optional StandardWert As String, _
                         Optional IniPfad As String)
  
  Dim sValue  As String, lResult  As Long

  If IniPfad = "" Then IniPfad = App.Path & "\" & App.Title & ".ini"
  sValue = Space$(255)
  lResult = GetPrivateProfileString(Abschnitt, SchlsselName, StandardWert, _
                                        sValue, Len(sValue), IniPfad)
  INI_Read = Left$(sValue, lResult)
End Function


' Beispiele zum Lschen:

'' Lschen eines einzelnen Eintrags aus der INI-Datei
'WritePrivateProfileString Abschnitt, Schlssel, vbNullString, IniPfad
'
'' Lschen eines gesamten Abschnittes
'WritePrivateProfileString Abschnitt, vbNullString, "", IniPfad
'
'' Lschen aller Abschnitte
'WritePrivateProfileString vbNullString, "", "", IniPfad

'Wie Sie anhand der Funktionsaufrufe sehen, knnen Teile der
'INI-Datei durch Eingabe von "vbNullString" gelscht werden - je
'nachdem, fr welchen Parameter Sie "vbNullString" einsetzen,
'handelt es sich um einen einzelnen Eintrag, einen einzelnen
'Abschnitt oder auch um alle Abschnitte.



